// chrome/common/caption.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "chrome/common/caption.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/common/caption.mojom-params-data.h"
#include "chrome/common/caption.mojom-shared-message-ids.h"

#include "chrome/common/caption.mojom-import-headers.h"


#ifndef CHROME_COMMON_CAPTION_MOJOM_JUMBO_H_
#define CHROME_COMMON_CAPTION_MOJOM_JUMBO_H_
#endif
namespace chrome {
namespace mojom {
TranscriptionResult::TranscriptionResult()
    : transcription(),
      is_final() {}

TranscriptionResult::TranscriptionResult(
    const std::string& transcription_in,
    bool is_final_in)
    : transcription(std::move(transcription_in)),
      is_final(std::move(is_final_in)) {}

TranscriptionResult::~TranscriptionResult() = default;
size_t TranscriptionResult::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->transcription);
  seed = mojo::internal::Hash(seed, this->is_final);
  return seed;
}

bool TranscriptionResult::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char CaptionHost::Name_[] = "chrome.mojom.CaptionHost";

CaptionHostProxy::CaptionHostProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void CaptionHostProxy::OnTranscription(
    TranscriptionResultPtr in_transcription_result) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "chrome::mojom::CaptionHost::OnTranscription");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kCaptionHost_OnTranscription_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::chrome::mojom::internal::CaptionHost_OnTranscription_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->transcription_result)::BaseType::BufferWriter
      transcription_result_writer;
  mojo::internal::Serialize<::chrome::mojom::TranscriptionResultDataView>(
      in_transcription_result, buffer, &transcription_result_writer, &serialization_context);
  params->transcription_result.Set(
      transcription_result_writer.is_null() ? nullptr : transcription_result_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->transcription_result.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null transcription_result in CaptionHost.OnTranscription request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(CaptionHost::Name_);
  message.set_method_name("OnTranscription");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool CaptionHostStubDispatch::Accept(
    CaptionHost* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kCaptionHost_OnTranscription_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)chrome::mojom::CaptionHost::OnTranscription",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)chrome::mojom::CaptionHost::OnTranscription");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::CaptionHost_OnTranscription_Params_Data* params =
          reinterpret_cast<internal::CaptionHost_OnTranscription_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      TranscriptionResultPtr p_transcription_result{};
      CaptionHost_OnTranscription_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadTranscriptionResult(&p_transcription_result))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            CaptionHost::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnTranscription(
std::move(p_transcription_result));
      return true;
    }
  }
  return false;
}

// static
bool CaptionHostStubDispatch::AcceptWithResponder(
    CaptionHost* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kCaptionHost_OnTranscription_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kCaptionHostValidationInfo[] = {
    {internal::kCaptionHost_OnTranscription_Name,
     {&internal::CaptionHost_OnTranscription_Params_Data::Validate,
      nullptr /* no response */}},
};

bool CaptionHostRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::chrome::mojom::CaptionHost::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kCaptionHostValidationInfo);
}

}  // namespace mojom
}  // namespace chrome

namespace mojo {


// static
bool StructTraits<::chrome::mojom::TranscriptionResult::DataView, ::chrome::mojom::TranscriptionResultPtr>::Read(
    ::chrome::mojom::TranscriptionResult::DataView input,
    ::chrome::mojom::TranscriptionResultPtr* output) {
  bool success = true;
  ::chrome::mojom::TranscriptionResultPtr result(::chrome::mojom::TranscriptionResult::New());
  
      if (success && !input.ReadTranscription(&result->transcription))
        success = false;
      if (success)
        result->is_final = input.is_final();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif