// services/network/public/mojom/cross_origin_opener_policy.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_CROSS_ORIGIN_OPENER_POLICY_MOJOM_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_CROSS_ORIGIN_OPENER_POLICY_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/network/public/mojom/cross_origin_opener_policy.mojom-shared.h"
#include "services/network/public/mojom/cross_origin_opener_policy.mojom-forward.h"
#include <string>
#include <vector>




#include "services/network/public/cpp/cross_origin_opener_policy_mojom_traits.h"




namespace network {
namespace mojom {





class  CrossOriginOpenerPolicy {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<CrossOriginOpenerPolicy, T>::value>;
  using DataView = CrossOriginOpenerPolicyDataView;
  using Data_ = internal::CrossOriginOpenerPolicy_Data;

  template <typename... Args>
  static CrossOriginOpenerPolicyPtr New(Args&&... args) {
    return CrossOriginOpenerPolicyPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static CrossOriginOpenerPolicyPtr From(const U& u) {
    return mojo::TypeConverter<CrossOriginOpenerPolicyPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, CrossOriginOpenerPolicy>::Convert(*this);
  }


  CrossOriginOpenerPolicy();

  CrossOriginOpenerPolicy(
      CrossOriginOpenerPolicyValue value,
      const base::Optional<std::string>& reporting_endpoint,
      CrossOriginOpenerPolicyValue report_only_value,
      const base::Optional<std::string>& report_only_reporting_endpoint);

  ~CrossOriginOpenerPolicy();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = CrossOriginOpenerPolicyPtr>
  CrossOriginOpenerPolicyPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, CrossOriginOpenerPolicy::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        CrossOriginOpenerPolicy::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        CrossOriginOpenerPolicy::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::CrossOriginOpenerPolicy_UnserializedMessageContext<
            UserType, CrossOriginOpenerPolicy::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<CrossOriginOpenerPolicy::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return CrossOriginOpenerPolicy::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::CrossOriginOpenerPolicy_UnserializedMessageContext<
            UserType, CrossOriginOpenerPolicy::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<CrossOriginOpenerPolicy::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  CrossOriginOpenerPolicyValue value;
  
  base::Optional<std::string> reporting_endpoint;
  
  CrossOriginOpenerPolicyValue report_only_value;
  
  base::Optional<std::string> report_only_reporting_endpoint;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, CrossOriginOpenerPolicy::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, CrossOriginOpenerPolicy::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, CrossOriginOpenerPolicy::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, CrossOriginOpenerPolicy::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
CrossOriginOpenerPolicyPtr CrossOriginOpenerPolicy::Clone() const {
  return New(
      mojo::Clone(value),
      mojo::Clone(reporting_endpoint),
      mojo::Clone(report_only_value),
      mojo::Clone(report_only_reporting_endpoint)
  );
}

template <typename T, CrossOriginOpenerPolicy::EnableIfSame<T>*>
bool CrossOriginOpenerPolicy::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  if (!mojo::Equals(this->reporting_endpoint, other_struct.reporting_endpoint))
    return false;
  if (!mojo::Equals(this->report_only_value, other_struct.report_only_value))
    return false;
  if (!mojo::Equals(this->report_only_reporting_endpoint, other_struct.report_only_reporting_endpoint))
    return false;
  return true;
}

template <typename T, CrossOriginOpenerPolicy::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.value < rhs.value)
    return true;
  if (rhs.value < lhs.value)
    return false;
  if (lhs.reporting_endpoint < rhs.reporting_endpoint)
    return true;
  if (rhs.reporting_endpoint < lhs.reporting_endpoint)
    return false;
  if (lhs.report_only_value < rhs.report_only_value)
    return true;
  if (rhs.report_only_value < lhs.report_only_value)
    return false;
  if (lhs.report_only_reporting_endpoint < rhs.report_only_reporting_endpoint)
    return true;
  if (rhs.report_only_reporting_endpoint < lhs.report_only_reporting_endpoint)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace network

namespace mojo {


template <>
struct  StructTraits<::network::mojom::CrossOriginOpenerPolicy::DataView,
                                         ::network::mojom::CrossOriginOpenerPolicyPtr> {
  static bool IsNull(const ::network::mojom::CrossOriginOpenerPolicyPtr& input) { return !input; }
  static void SetToNull(::network::mojom::CrossOriginOpenerPolicyPtr* output) { output->reset(); }

  static decltype(::network::mojom::CrossOriginOpenerPolicy::value) value(
      const ::network::mojom::CrossOriginOpenerPolicyPtr& input) {
    return input->value;
  }

  static const decltype(::network::mojom::CrossOriginOpenerPolicy::reporting_endpoint)& reporting_endpoint(
      const ::network::mojom::CrossOriginOpenerPolicyPtr& input) {
    return input->reporting_endpoint;
  }

  static decltype(::network::mojom::CrossOriginOpenerPolicy::report_only_value) report_only_value(
      const ::network::mojom::CrossOriginOpenerPolicyPtr& input) {
    return input->report_only_value;
  }

  static const decltype(::network::mojom::CrossOriginOpenerPolicy::report_only_reporting_endpoint)& report_only_reporting_endpoint(
      const ::network::mojom::CrossOriginOpenerPolicyPtr& input) {
    return input->report_only_reporting_endpoint;
  }

  static bool Read(::network::mojom::CrossOriginOpenerPolicy::DataView input, ::network::mojom::CrossOriginOpenerPolicyPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_CROSS_ORIGIN_OPENER_POLICY_MOJOM_H_