// third_party/blink/public/mojom/input/input_event.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_INPUT_INPUT_EVENT_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_INPUT_INPUT_EVENT_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/blink/public/mojom/input/input_event.mojom-shared-internal.h"



#include "base/component_export.h"




namespace blink {
namespace mojom {


}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {


enum class Button : int32_t {
  
  kNoButton = -1,
  
  kLeft,
  
  kMiddle,
  
  kRight,
  
  kBarrel = Button::kRight,
  
  kBack,
  
  kForward,
  
  kEraser,
  kMinValue = -1,
  kMaxValue = 5,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, Button value);
inline bool IsKnownEnumValue(Button value) {
  return internal::Button_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class DispatchType : int32_t {
  
  kBlocking,
  
  kEventNonBlocking,
  
  kListenersNonBlockingPassive,
  
  kListenersForcedNonBlockingDueToFling,
  kMinValue = 0,
  kMaxValue = 3,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, DispatchType value);
inline bool IsKnownEnumValue(DispatchType value) {
  return internal::DispatchType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class EventType : int32_t {
  
  kUndefined = -1,
  
  kTypeFirst = EventType::kUndefined,
  
  kMouseDown,
  
  kMouseTypeFirst = EventType::kMouseDown,
  
  kMouseUp,
  
  kMouseMove,
  
  kMouseEnter,
  
  kMouseLeave,
  
  kContextMenu,
  
  kMouseTypeLast = EventType::kContextMenu,
  
  kMouseWheel,
  
  kRawKeyDown,
  
  kKeyboardTypeFirst = EventType::kRawKeyDown,
  
  kKeyDown,
  
  kKeyUp,
  
  kChar,
  
  kKeyboardTypeLast = EventType::kChar,
  
  kGestureScrollBegin,
  
  kGestureTypeFirst = EventType::kGestureScrollBegin,
  
  kGestureScrollEnd,
  
  kGestureScrollUpdate,
  
  kGestureFlingStart,
  
  kGestureFlingCancel,
  
  kGesturePinchBegin,
  
  kGesturePinchTypeFirst = EventType::kGesturePinchBegin,
  
  kGesturePinchEnd,
  
  kGesturePinchUpdate,
  
  kGesturePinchTypeLast = EventType::kGesturePinchUpdate,
  
  kGestureTapDown,
  
  kGestureShowPress,
  
  kGestureTap,
  
  kGestureTapCancel,
  
  kGestureLongPress,
  
  kGestureLongTap,
  
  kGestureTwoFingerTap,
  
  kGestureTapUnconfirmed,
  
  kGestureDoubleTap,
  
  kGestureTypeLast = EventType::kGestureDoubleTap,
  
  kTouchStart,
  
  kTouchTypeFirst = EventType::kTouchStart,
  
  kTouchMove,
  
  kTouchEnd,
  
  kTouchCancel,
  
  kTouchScrollStarted,
  
  kTouchTypeLast = EventType::kTouchScrollStarted,
  
  kPointerDown,
  
  kPointerTypeFirst = EventType::kPointerDown,
  
  kPointerUp,
  
  kPointerMove,
  
  kPointerRawUpdate,
  
  kPointerCancel,
  
  kPointerCausedUaAction,
  
  kPointerTypeLast = EventType::kPointerCausedUaAction,
  
  kTypeLast = EventType::kPointerTypeLast,
  kMinValue = -1,
  kMaxValue = 38,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, EventType value);
inline bool IsKnownEnumValue(EventType value) {
  return internal::EventType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


}  // namespace mojom
}  // namespace blink

namespace std {

template <>
struct hash<::blink::mojom::Button>
    : public mojo::internal::EnumHashImpl<::blink::mojom::Button> {};

template <>
struct hash<::blink::mojom::DispatchType>
    : public mojo::internal::EnumHashImpl<::blink::mojom::DispatchType> {};

template <>
struct hash<::blink::mojom::EventType>
    : public mojo::internal::EnumHashImpl<::blink::mojom::EventType> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::blink::mojom::Button, ::blink::mojom::Button> {
  static ::blink::mojom::Button ToMojom(::blink::mojom::Button input) { return input; }
  static bool FromMojom(::blink::mojom::Button input, ::blink::mojom::Button* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::Button, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::Button, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::Button>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::blink::mojom::DispatchType, ::blink::mojom::DispatchType> {
  static ::blink::mojom::DispatchType ToMojom(::blink::mojom::DispatchType input) { return input; }
  static bool FromMojom(::blink::mojom::DispatchType input, ::blink::mojom::DispatchType* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::DispatchType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::DispatchType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::DispatchType>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::blink::mojom::EventType, ::blink::mojom::EventType> {
  static ::blink::mojom::EventType ToMojom(::blink::mojom::EventType input) { return input; }
  static bool FromMojom(::blink::mojom::EventType input, ::blink::mojom::EventType* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::EventType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::EventType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::EventType>(input), output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {


}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_INPUT_INPUT_EVENT_MOJOM_SHARED_H_