// third_party/blink/public/mojom/input/input_handler.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_INPUT_INPUT_HANDLER_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_INPUT_INPUT_HANDLER_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/input/input_handler.mojom-shared.h"
#include "third_party/blink/public/mojom/input/input_handler.mojom-blink-forward.h"
#include "cc/mojom/overscroll_behavior.mojom-blink.h"
#include "cc/mojom/touch_action.mojom-blink.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"




#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "third_party/blink/renderer/platform/platform_export.h"




namespace blink {
namespace mojom {
namespace blink {






class PLATFORM_EXPORT TouchActionOptional {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<TouchActionOptional, T>::value>;
  using DataView = TouchActionOptionalDataView;
  using Data_ = internal::TouchActionOptional_Data;

  template <typename... Args>
  static TouchActionOptionalPtr New(Args&&... args) {
    return TouchActionOptionalPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TouchActionOptionalPtr From(const U& u) {
    return mojo::TypeConverter<TouchActionOptionalPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TouchActionOptional>::Convert(*this);
  }


  TouchActionOptional();

  explicit TouchActionOptional(
      ::cc::TouchAction touch_action);

  ~TouchActionOptional();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TouchActionOptionalPtr>
  TouchActionOptionalPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, TouchActionOptional::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        TouchActionOptional::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TouchActionOptional::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::TouchActionOptional_UnserializedMessageContext<
            UserType, TouchActionOptional::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<TouchActionOptional::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return TouchActionOptional::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::TouchActionOptional_UnserializedMessageContext<
            UserType, TouchActionOptional::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<TouchActionOptional::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::cc::TouchAction touch_action;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, TouchActionOptional::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, TouchActionOptional::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, TouchActionOptional::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, TouchActionOptional::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class PLATFORM_EXPORT EditCommand {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<EditCommand, T>::value>;
  using DataView = EditCommandDataView;
  using Data_ = internal::EditCommand_Data;

  template <typename... Args>
  static EditCommandPtr New(Args&&... args) {
    return EditCommandPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static EditCommandPtr From(const U& u) {
    return mojo::TypeConverter<EditCommandPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, EditCommand>::Convert(*this);
  }


  EditCommand();

  EditCommand(
      const WTF::String& name,
      const WTF::String& value);

  ~EditCommand();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = EditCommandPtr>
  EditCommandPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, EditCommand::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        EditCommand::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        EditCommand::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::EditCommand_UnserializedMessageContext<
            UserType, EditCommand::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<EditCommand::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return EditCommand::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::EditCommand_UnserializedMessageContext<
            UserType, EditCommand::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<EditCommand::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  WTF::String name;
  
  WTF::String value;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, EditCommand::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, EditCommand::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, EditCommand::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, EditCommand::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class PLATFORM_EXPORT DidOverscrollParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DidOverscrollParams, T>::value>;
  using DataView = DidOverscrollParamsDataView;
  using Data_ = internal::DidOverscrollParams_Data;

  template <typename... Args>
  static DidOverscrollParamsPtr New(Args&&... args) {
    return DidOverscrollParamsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DidOverscrollParamsPtr From(const U& u) {
    return mojo::TypeConverter<DidOverscrollParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DidOverscrollParams>::Convert(*this);
  }


  DidOverscrollParams();

  DidOverscrollParams(
      const ::gfx::Vector2dF& accumulated_overscroll,
      const ::gfx::Vector2dF& latest_overscroll_delta,
      const ::gfx::Vector2dF& current_fling_velocity,
      const ::gfx::PointF& causal_event_viewport_point,
      const ::cc::OverscrollBehavior& overscroll_behavior);

  ~DidOverscrollParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DidOverscrollParamsPtr>
  DidOverscrollParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DidOverscrollParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DidOverscrollParams::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DidOverscrollParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DidOverscrollParams_UnserializedMessageContext<
            UserType, DidOverscrollParams::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<DidOverscrollParams::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return DidOverscrollParams::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DidOverscrollParams_UnserializedMessageContext<
            UserType, DidOverscrollParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DidOverscrollParams::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::gfx::Vector2dF accumulated_overscroll;
  
  ::gfx::Vector2dF latest_overscroll_delta;
  
  ::gfx::Vector2dF current_fling_velocity;
  
  ::gfx::PointF causal_event_viewport_point;
  
  ::cc::OverscrollBehavior overscroll_behavior;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DidOverscrollParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DidOverscrollParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DidOverscrollParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DidOverscrollParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}



template <typename StructPtrType>
DidOverscrollParamsPtr DidOverscrollParams::Clone() const {
  return New(
      mojo::Clone(accumulated_overscroll),
      mojo::Clone(latest_overscroll_delta),
      mojo::Clone(current_fling_velocity),
      mojo::Clone(causal_event_viewport_point),
      mojo::Clone(overscroll_behavior)
  );
}

template <typename T, DidOverscrollParams::EnableIfSame<T>*>
bool DidOverscrollParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->accumulated_overscroll, other_struct.accumulated_overscroll))
    return false;
  if (!mojo::Equals(this->latest_overscroll_delta, other_struct.latest_overscroll_delta))
    return false;
  if (!mojo::Equals(this->current_fling_velocity, other_struct.current_fling_velocity))
    return false;
  if (!mojo::Equals(this->causal_event_viewport_point, other_struct.causal_event_viewport_point))
    return false;
  if (!mojo::Equals(this->overscroll_behavior, other_struct.overscroll_behavior))
    return false;
  return true;
}

template <typename T, DidOverscrollParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.accumulated_overscroll < rhs.accumulated_overscroll)
    return true;
  if (rhs.accumulated_overscroll < lhs.accumulated_overscroll)
    return false;
  if (lhs.latest_overscroll_delta < rhs.latest_overscroll_delta)
    return true;
  if (rhs.latest_overscroll_delta < lhs.latest_overscroll_delta)
    return false;
  if (lhs.current_fling_velocity < rhs.current_fling_velocity)
    return true;
  if (rhs.current_fling_velocity < lhs.current_fling_velocity)
    return false;
  if (lhs.causal_event_viewport_point < rhs.causal_event_viewport_point)
    return true;
  if (rhs.causal_event_viewport_point < lhs.causal_event_viewport_point)
    return false;
  if (lhs.overscroll_behavior < rhs.overscroll_behavior)
    return true;
  if (rhs.overscroll_behavior < lhs.overscroll_behavior)
    return false;
  return false;
}
template <typename StructPtrType>
TouchActionOptionalPtr TouchActionOptional::Clone() const {
  return New(
      mojo::Clone(touch_action)
  );
}

template <typename T, TouchActionOptional::EnableIfSame<T>*>
bool TouchActionOptional::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->touch_action, other_struct.touch_action))
    return false;
  return true;
}

template <typename T, TouchActionOptional::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.touch_action < rhs.touch_action)
    return true;
  if (rhs.touch_action < lhs.touch_action)
    return false;
  return false;
}
template <typename StructPtrType>
EditCommandPtr EditCommand::Clone() const {
  return New(
      mojo::Clone(name),
      mojo::Clone(value)
  );
}

template <typename T, EditCommand::EnableIfSame<T>*>
bool EditCommand::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  return true;
}

template <typename T, EditCommand::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.value < rhs.value)
    return true;
  if (rhs.value < lhs.value)
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::DidOverscrollParams::DataView,
                                         ::blink::mojom::blink::DidOverscrollParamsPtr> {
  static bool IsNull(const ::blink::mojom::blink::DidOverscrollParamsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::DidOverscrollParamsPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::DidOverscrollParams::accumulated_overscroll)& accumulated_overscroll(
      const ::blink::mojom::blink::DidOverscrollParamsPtr& input) {
    return input->accumulated_overscroll;
  }

  static const decltype(::blink::mojom::blink::DidOverscrollParams::latest_overscroll_delta)& latest_overscroll_delta(
      const ::blink::mojom::blink::DidOverscrollParamsPtr& input) {
    return input->latest_overscroll_delta;
  }

  static const decltype(::blink::mojom::blink::DidOverscrollParams::current_fling_velocity)& current_fling_velocity(
      const ::blink::mojom::blink::DidOverscrollParamsPtr& input) {
    return input->current_fling_velocity;
  }

  static const decltype(::blink::mojom::blink::DidOverscrollParams::causal_event_viewport_point)& causal_event_viewport_point(
      const ::blink::mojom::blink::DidOverscrollParamsPtr& input) {
    return input->causal_event_viewport_point;
  }

  static const decltype(::blink::mojom::blink::DidOverscrollParams::overscroll_behavior)& overscroll_behavior(
      const ::blink::mojom::blink::DidOverscrollParamsPtr& input) {
    return input->overscroll_behavior;
  }

  static bool Read(::blink::mojom::blink::DidOverscrollParams::DataView input, ::blink::mojom::blink::DidOverscrollParamsPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::TouchActionOptional::DataView,
                                         ::blink::mojom::blink::TouchActionOptionalPtr> {
  static bool IsNull(const ::blink::mojom::blink::TouchActionOptionalPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::TouchActionOptionalPtr* output) { output->reset(); }

  static decltype(::blink::mojom::blink::TouchActionOptional::touch_action) touch_action(
      const ::blink::mojom::blink::TouchActionOptionalPtr& input) {
    return input->touch_action;
  }

  static bool Read(::blink::mojom::blink::TouchActionOptional::DataView input, ::blink::mojom::blink::TouchActionOptionalPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::EditCommand::DataView,
                                         ::blink::mojom::blink::EditCommandPtr> {
  static bool IsNull(const ::blink::mojom::blink::EditCommandPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::EditCommandPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::EditCommand::name)& name(
      const ::blink::mojom::blink::EditCommandPtr& input) {
    return input->name;
  }

  static const decltype(::blink::mojom::blink::EditCommand::value)& value(
      const ::blink::mojom::blink::EditCommandPtr& input) {
    return input->value;
  }

  static bool Read(::blink::mojom::blink::EditCommand::DataView input, ::blink::mojom::blink::EditCommandPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_INPUT_INPUT_HANDLER_MOJOM_BLINK_H_